template <typename T>
class RCPtr
{
public:
	RCPtr(T* realPtr = 0);						// 
	RCPtr(const RCPtr& rhs);					//  
	~RCPtr();

	RCPtr& operator=(const RCPtr& rhs);			// Կ 

	T& operator*() const;
	T* operator->() const;

private:

	// ͸  縦  ڿ Կڸ ݵ 
	T* pointee;									
	void init();
};

template<typename T>
void RCPtr<T>::init()	//  Լ ̽ ϴ ü ´ٴ° .
{
	if(pointee == NULL)
		return;

	if(pointee->isShareable() == false)
		pointee = new T(*pointee);

	pointee->addReference();
}

template<typename T>
RCPtr<T>::RCPtr(T* realPtr /* = 0 */) 
: pointee(realPtr)
{
	init();
}

template<typename T>
RCPtr<T>::RCPtr(const RCPtr& rhs)
: pointee(rhs.pointee)
{
	init();
}

template<typename T>
RCPtr<T>::~RCPtr()
{
	if(pointee)
		pointee->removeReference();
}

template<typename T>
RCPtr<T>& RCPtr<T>::operator =(const RCPtr& rhs)
{	
	if(pointee==rhs.pointee)
		return *this;

	T* oldPointee = pointee;		//  
	pointee = rhs.pointee;			//  
	init();							// ʱȭ
	if(oldPointee)
		oldPointee->removeReference();

	return *this;
}

template<typename T>
T* RCPtr<T>::operator ->() const 
{ return pointee; }

template<typename T>
T& RCPtr<T>::operator *() const
{ return *pointee; }